﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Media;
using Infragistics.Windows.DataPresenter;
using Infragistics.Windows.DataPresenter.Events;
using Infragistics.Windows.Editors;

namespace IgSample
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            var dataSource = new List<DataItem>
                                 {
                                     new DataItem {Property1 = "", Property2 = "Hello", Property3 = true},
                                     new DataItem {Property1 = "#2", Property2 = "World", Property3 = false}
                                 };

            foreach (var item in dataSource)
            {
                item.MetaData = new MetaData(item);
            }



            xdg.RecordAdded += Grid_RecordAdded;
            InitTrigger(xdg);

            xdg.DataSource = new BindingList<DataItem>(dataSource);
//            xdg.RecordsInViewChanged += XamDataGrid_RecordsInViewChanged;



        }

        void Dummy(object sender, RoutedPropertyChangedEventArgs<object> e)
        {
            (sender as XamCheckEditor).EndEditMode(true, false);
            (sender as XamCheckEditor).StartEditMode();
        }

        private void Grid_RecordAdded(object sender, RecordAddedEventArgs e)
        {
            var item = (DataItem) e.Record.DataItem;
            item.MetaData = new MetaData(item);
        }


        private void InitTrigger(XamDataGrid xdg)
        {
            var style = new Style(typeof(CellValuePresenter));
            var baseStyle = xdg.TryFindResource(typeof(CellValuePresenter)) as Style;
            if (baseStyle != null)
            {
                style.BasedOn = baseStyle;
            }

            foreach (var field in xdg.FieldLayouts[0].Fields)
            {
                var bindingPath = "DataItem.MetaData.IsValid";
                        var dtTrue = new DataTrigger
                                         {
                                             Binding = new Binding(bindingPath),
                                             Value = true,
                                         };
                        var dtFalse = new DataTrigger
                        {
                            Binding = new Binding(bindingPath),
                            Value = false,
                        };
                        dtTrue.Setters.Add(new Setter(Control.BorderThicknessProperty, new Thickness(1)));
                        dtTrue.Setters.Add(new Setter(Control.BorderBrushProperty, Brushes.Green));

                        dtFalse.Setters.Add(new Setter(Control.BorderThicknessProperty, new Thickness(1)));
                        dtFalse.Setters.Add(new Setter(Control.BorderBrushProperty, Brushes.Red));

                        style.Triggers.Add(dtTrue);
                        style.Triggers.Add(dtFalse);
                        field.Settings.CellValuePresenterStyle = style;
                    }
                }
            }
        }
